]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
emacs: Add new option notmuch-search-hide-excluded
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For emacsclient
108 unset ALTERNATE_EDITOR
109
110 add_gnupg_home ()
111 {
112     [ -e "${GNUPGHOME}/gpg.conf" ] && return
113     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
114     at_exit_function _gnupg_exit
115     mkdir -p -m 0700 "$GNUPGHOME"
116     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
117     test_debug "cat $GNUPGHOME/import.log"
118     if (gpg --quick-random --version >/dev/null 2>&1) ; then
119         echo quick-random >> "$GNUPGHOME"/gpg.conf
120     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
121         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
122     fi
123     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
124
125     # Change this if we ship a new test key
126     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
127     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
128     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
129 }
130
131 add_gpgsm_home ()
132 {
133     local fpr
134     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
135     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
136     at_exit_function _gnupg_exit
137     mkdir -p -m 0700 "$GNUPGHOME"
138     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
139         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
140         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
141               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
142     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
143     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
144     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
145     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
146     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
147     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
148               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
149     test_debug "cat $GNUPGHOME/import.log"
150 }
151
152 # Each test should start with something like this, after copyright notices:
153 #
154 # test_description='Description of this test...
155 # This test checks if command xyzzy does the right thing...
156 # '
157 # . ./test-lib.sh || exit 1
158
159 color=maybe
160
161 while test "$#" -ne 0
162 do
163         case "$1" in
164         -d|--debug)
165                 debug=t; shift ;;
166         -i|--immediate)
167                 immediate=t; shift ;;
168         -h|--help)
169                 help=t; shift ;;
170         -v|--verbose)
171                 verbose=t; shift ;;
172         -q|--quiet)
173                 quiet=t; shift ;;
174         --with-dashes)
175                 with_dashes=t; shift ;;
176         --no-color)
177                 color=; shift ;;
178         --no-python)
179                 # noop now...
180                 shift ;;
181         --valgrind)
182                 valgrind=t; verbose=t; shift ;;
183         --tee)
184                 shift ;; # was handled already
185         *)
186                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
187         esac
188 done
189
190 if test -n "$debug"; then
191     print_subtest () {
192         printf " %-4s" "[$((test_count - 1))]"
193     }
194 else
195     print_subtest () {
196         true
197     }
198 fi
199
200 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
201
202 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
203                 TERM=$ORIGINAL_TERM &&
204                 export TERM &&
205                 tput bold
206                 tput setaf
207                 tput sgr0
208         ) >/dev/null 2>&1
209 then
210         color=t
211 else
212         color=
213 fi
214
215 if test -n "$color"; then
216         say_color () {
217                 (
218                 TERM=$ORIGINAL_TERM
219                 export TERM
220                 case "$1" in
221                         error) tput bold; tput setaf 1;; # bold red
222                         skip)  tput bold; tput setaf 2;; # bold green
223                         pass)  tput setaf 2;;            # green
224                         info)  tput setaf 3;;            # brown
225                         *) test -n "$quiet" && return;;
226                 esac
227                 shift
228                 printf " "
229                 printf "$@"
230                 tput sgr0
231                 print_subtest
232                 )
233         }
234 else
235         say_color() {
236                 test -z "$1" && test -n "$quiet" && return
237                 shift
238                 printf " "
239                 printf "$@"
240                 print_subtest
241         }
242 fi
243
244 error () {
245         say_color error "error: $*\n"
246         GIT_EXIT_OK=t
247         exit 1
248 }
249
250 say () {
251         say_color info "$*"
252 }
253
254 test "${test_description}" != "" ||
255 error "Test script did not set test_description."
256
257 if test "$help" = "t"
258 then
259         echo "Tests ${test_description}"
260         exit 0
261 fi
262
263 test_description_printed=
264 print_test_description ()
265 {
266         test -z "$test_description_printed" || return 0
267         echo
268         echo $this_test: "Testing ${test_description}"
269         test_description_printed=1
270 }
271 if [ -z "$NOTMUCH_TEST_QUIET" ]
272 then
273         print_test_description
274 fi
275
276 test_failure=0
277 test_count=0
278 test_fixed=0
279 test_broken=0
280 test_success=0
281
282 declare -a _exit_functions=()
283
284 at_exit_function () {
285         _exit_functions=($1 ${_exit_functions[@]/$1})
286 }
287
288 rm_exit_function () {
289         _exit_functions=(${_exit_functions[@]/$1})
290 }
291
292 _exit_common () {
293         code=$?
294         trap - EXIT
295         set +ex
296         for _fn in ${_exit_functions[@]}; do $_fn; done
297         rm -rf "$TEST_TMPDIR"
298 }
299
300 trap_exit () {
301         _exit_common
302         if test -n "$GIT_EXIT_OK"
303         then
304                 exit $code
305         else
306                 exec >&6
307                 say_color error '%-6s' FATAL
308                 echo " $test_subtest_name"
309                 echo
310                 echo "Unexpected exit while executing $0. Exit code $code."
311                 exit 1
312         fi
313 }
314
315 trap_signal () {
316         _exit_common
317         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
318         exit $code
319 }
320
321 die () {
322         _exit_common
323         exec >&6
324         say_color error '%-6s' FATAL
325         echo " $*"
326         echo
327         echo "Unexpected exit while executing $0."
328         exit 1
329 }
330
331 GIT_EXIT_OK=
332 # Note: TEST_TMPDIR *NOT* exported!
333 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
334 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
335 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
336 trap 'trap_exit' EXIT
337 trap 'trap_signal' HUP INT TERM
338
339 # Deliver a message with emacs and add it to the database
340 #
341 # Uses emacs to generate and deliver a message to the mail store.
342 # Accepts arbitrary extra emacs/elisp functions to modify the message
343 # before sending, which is useful to doing things like attaching files
344 # to the message and encrypting/signing.
345 emacs_deliver_message ()
346 {
347     local subject body smtp_dummy_pid smtp_dummy_port
348     subject="$1"
349     body="$2"
350     shift 2
351     # before we can send a message, we have to prepare the FCC maildir
352     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
353     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
354     smtp_dummy_pid= smtp_dummy_port=
355     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
356     test -n "$smtp_dummy_pid" || return 1
357     test -n "$smtp_dummy_port" || return 1
358
359     test_emacs \
360         "(let ((message-send-mail-function 'message-smtpmail-send-it)
361                (mail-host-address \"example.com\")
362                (smtpmail-smtp-server \"localhost\")
363                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
364            (notmuch-mua-mail)
365            (message-goto-to)
366            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
367            (message-goto-subject)
368            (insert \"${subject}\")
369            (message-goto-body)
370            (insert \"${body}\")
371            $*
372            (notmuch-mua-send-and-exit))"
373
374     # In case message was sent properly, client waits for confirmation
375     # before exiting and resuming control here; therefore making sure
376     # that server exits by sending (KILL) signal to it is safe.
377     kill -9 $smtp_dummy_pid
378     notmuch new >/dev/null
379 }
380
381 # Pretend to deliver a message with emacs. Really save it to a file
382 # and add it to the database
383 #
384 # Uses emacs to generate and deliver a message to the mail store.
385 # Accepts arbitrary extra emacs/elisp functions to modify the message
386 # before sending, which is useful to doing things like attaching files
387 # to the message and encrypting/signing.
388 #
389 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
390 # at the head of the argument list, they are sent directly to "notmuch
391 # new" after message delivery
392 emacs_fcc_message ()
393 {
394     local nmn_args subject body
395     nmn_args=''
396     while [[ "$1" =~ ^-- ]]; do
397         nmn_args="$nmn_args $1"
398         shift
399     done
400     subject="$1"
401     body="$2"
402     shift 2
403     # before we can send a message, we have to prepare the FCC maildir
404     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
405
406     test_emacs \
407         "(let ((message-send-mail-function (lambda () t))
408                (mail-host-address \"example.com\"))
409            (notmuch-mua-mail)
410            (message-goto-to)
411            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
412            (message-goto-subject)
413            (insert \"${subject}\")
414            (message-goto-body)
415            (insert \"${body}\")
416            $*
417            (let ((mml-secure-smime-sign-with-sender t)
418                  (mml-secure-openpgp-sign-with-sender t))
419              (notmuch-mua-send-and-exit)))" || return 1
420     notmuch new $nmn_args >/dev/null
421 }
422
423 # Add an existing, fixed corpus of email to the database.
424 #
425 # $1 is the corpus dir under corpora to add, using "default" if unset.
426 #
427 # The default corpus is based on about 50 messages from early in the
428 # history of the notmuch mailing list, which allows for reliably
429 # testing commands that need to operate on a not-totally-trivial
430 # number of messages.
431 add_email_corpus ()
432 {
433     local corpus
434     corpus=${1:-default}
435
436     rm -rf ${MAIL_DIR}
437     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
438     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
439 }
440
441 test_begin_subtest ()
442 {
443     if [ -n "$inside_subtest" ]; then
444         exec 1>&6 2>&7          # Restore stdout and stderr
445         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
446     fi
447     test_subtest_name="$1"
448     test_reset_state_
449     # Redirect test output to the previously prepared file descriptors
450     # 3 and 4 (see below)
451     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
452     exec >&3 2>&4
453     inside_subtest=t
454 }
455
456 # Pass test if two arguments match
457 #
458 # Note: Unlike all other test_expect_* functions, this function does
459 # not accept a test name. Instead, the caller should call
460 # test_begin_subtest before calling this function in order to set the
461 # name.
462 test_expect_equal ()
463 {
464         local output expected testname
465         exec 1>&6 2>&7          # Restore stdout and stderr
466         if [ -z "$inside_subtest" ]; then
467                 error "bug in the test script: test_expect_equal without test_begin_subtest"
468         fi
469         inside_subtest=
470         test "$#" = 2 ||
471         error "bug in the test script: not 2 parameters to test_expect_equal"
472
473         output="$1"
474         expected="$2"
475         if ! test_skip "$test_subtest_name"
476         then
477                 if [ "$output" = "$expected" ]; then
478                         test_ok_
479                 else
480                         testname=$this_test.$test_count
481                         echo "$expected" > $testname.expected
482                         echo "$output" > $testname.output
483                         test_failure_ "$(diff -u $testname.expected $testname.output)"
484                 fi
485     fi
486 }
487
488 # Like test_expect_equal, but takes two filenames.
489 test_expect_equal_file ()
490 {
491         local file1 file2 testname basename1 basename2
492         exec 1>&6 2>&7          # Restore stdout and stderr
493         if [ -z "$inside_subtest" ]; then
494                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
495         fi
496         inside_subtest=
497         test "$#" = 2 ||
498         error "bug in the test script: not 2 parameters to test_expect_equal_file"
499
500         file1="$1"
501         file2="$2"
502         if ! test_skip "$test_subtest_name"
503         then
504                 if diff -q "$file1" "$file2" >/dev/null ; then
505                         test_ok_
506                 else
507                         testname=$this_test.$test_count
508                         basename1=`basename "$file1"`
509                         basename2=`basename "$file2"`
510                         cp "$file1" "$testname.$basename1"
511                         cp "$file2" "$testname.$basename2"
512                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
513                 fi
514     fi
515 }
516
517 # Like test_expect_equal, but arguments are JSON expressions to be
518 # canonicalized before diff'ing.  If an argument cannot be parsed, it
519 # is used unchanged so that there's something to diff against.
520 test_expect_equal_json () {
521     local script output expected
522     # The test suite forces LC_ALL=C, but this causes Python 3 to
523     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
524     # override Python's stdio encoding defaults.
525     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
526     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
527         || echo "$1")
528     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
529         || echo "$2")
530     shift 2
531     test_expect_equal "$output" "$expected" "$@"
532 }
533
534 # Ensure that the argument is valid JSON data.
535 test_valid_json () {
536     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
537     test_expect_equal "$?" 0
538 }
539
540 # Sort the top-level list of JSON data from stdin.
541 test_sort_json () {
542     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
543         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
544 }
545
546 # test for json objects:
547 # read the source of test/json_check_nodes.py (or the output when
548 # invoking it without arguments) for an explanation of the syntax.
549 test_json_nodes () {
550         local output
551         exec 1>&6 2>&7          # Restore stdout and stderr
552         if [ -z "$inside_subtest" ]; then
553                 error "bug in the test script: test_json_eval without test_begin_subtest"
554         fi
555         inside_subtest=
556         test "$#" > 0 ||
557             error "bug in the test script: test_json_nodes needs at least 1 parameter"
558
559         if ! test_skip "$test_subtest_name"
560         then
561             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
562                 if [ "$?" = 0 ]
563                 then
564                         test_ok_
565                 else
566                         test_failure_ "$output"
567                 fi
568         fi
569 }
570
571 test_emacs_expect_t () {
572         local result
573         test "$#" = 1 ||
574         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
575         if [ -z "$inside_subtest" ]; then
576                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
577         fi
578
579         # Run the test.
580         if ! test_skip "$test_subtest_name"
581         then
582                 test_emacs "(notmuch-test-run $1)" >/dev/null
583
584                 # Restore state after the test.
585                 exec 1>&6 2>&7          # Restore stdout and stderr
586                 inside_subtest=
587
588                 # Report success/failure.
589                 result=$(cat OUTPUT)
590                 if [ "$result" = t ]
591                 then
592                         test_ok_
593                 else
594                         test_failure_ "${result}"
595                 fi
596         else
597                 # Restore state after the (non) test.
598                 exec 1>&6 2>&7          # Restore stdout and stderr
599                 inside_subtest=
600         fi
601 }
602
603 NOTMUCH_NEW ()
604 {
605     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
606 }
607
608 NOTMUCH_DUMP_TAGS ()
609 {
610     # this relies on the default format being batch-tag, otherwise some tests will break
611     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
612 }
613
614 notmuch_drop_mail_headers ()
615 {
616     $NOTMUCH_PYTHON -c '
617 import email, sys
618 msg = email.message_from_file(sys.stdin)
619 for hdr in sys.argv[1:]: del msg[hdr]
620 print(msg.as_string(False))
621 ' "$@"
622 }
623
624 notmuch_exception_sanitize ()
625 {
626     perl -pe 's/(A Xapian exception occurred at .*[.]cc?):([0-9]*)/\1:XXX/'
627 }
628
629 notmuch_search_sanitize ()
630 {
631     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
632 }
633
634 notmuch_search_files_sanitize ()
635 {
636     notmuch_dir_sanitize
637 }
638
639 notmuch_dir_sanitize ()
640 {
641     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
642 }
643
644 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
645 notmuch_show_sanitize ()
646 {
647     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
648 }
649 notmuch_show_sanitize_all ()
650 {
651     sed \
652         -e 's| filename:.*| filename:XXXXX|' \
653         -e 's| id:[^ ]* | id:XXXXX |' | \
654         notmuch_date_sanitize
655 }
656
657 notmuch_json_show_sanitize ()
658 {
659     sed \
660         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
661         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
662         -e 's|"filename": "signature.asc",||g' \
663         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
664         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
665         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
666 }
667
668 notmuch_emacs_error_sanitize ()
669 {
670     local command
671     command=$1
672     shift
673     for file in "$@"; do
674         echo "=== $file ==="
675         cat "$file"
676     done | sed \
677         -e 's/^\[.*\]$/[XXX]/' \
678         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
679 }
680
681 notmuch_date_sanitize ()
682 {
683     sed \
684         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
685 }
686
687 notmuch_uuid_sanitize ()
688 {
689     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
690 }
691
692 notmuch_built_with_sanitize ()
693 {
694     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
695 }
696
697 notmuch_config_sanitize ()
698 {
699     notmuch_dir_sanitize | notmuch_built_with_sanitize
700 }
701
702 notmuch_show_part ()
703 {
704     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
705 }
706
707 # End of notmuch helper functions
708
709 # Use test_set_prereq to tell that a particular prerequisite is available.
710 #
711 # The prerequisite can later be checked for by using test_have_prereq.
712 #
713 # The single parameter is the prerequisite tag (a simple word, in all
714 # capital letters by convention).
715
716 test_set_prereq () {
717         satisfied="$satisfied$1 "
718 }
719 satisfied=" "
720
721 test_have_prereq () {
722         case $satisfied in
723         *" $1 "*)
724                 : yes, have it ;;
725         *)
726                 ! : nope ;;
727         esac
728 }
729
730 declare -A test_missing_external_prereq_
731 declare -A test_subtest_missing_external_prereq_
732
733 # declare prerequisite for the given external binary
734 test_declare_external_prereq () {
735         local binary
736         binary="$1"
737         test "$#" = 2 && name=$2 || name="$binary(1)"
738
739         if ! hash $binary 2>/dev/null; then
740                 test_missing_external_prereq_["${binary}"]=t
741                 eval "
742 $binary () {
743         test_subtest_missing_external_prereq_[\"${name}\"]=t
744         false
745 }"
746         fi
747 }
748
749 # Explicitly require external prerequisite.  Useful when binary is
750 # called indirectly (e.g. from emacs).
751 # Returns success if dependency is available, failure otherwise.
752 test_require_external_prereq () {
753         local binary
754         binary="$1"
755         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
756                 # dependency is missing, call the replacement function to note it
757                 eval "$binary"
758         else
759                 true
760         fi
761 }
762
763 # You are not expected to call test_ok_ and test_failure_ directly, use
764 # the text_expect_* functions instead.
765
766 test_ok_ () {
767         if test "$test_subtest_known_broken_" = "t"; then
768                 test_known_broken_ok_
769                 return
770         fi
771         test_success=$(($test_success + 1))
772         if test -n "$NOTMUCH_TEST_QUIET"; then
773                 return 0
774         fi
775         say_color pass "%-6s" "PASS"
776         echo " $test_subtest_name"
777 }
778
779 test_failure_ () {
780         print_test_description
781         if test "$test_subtest_known_broken_" = "t"; then
782                 test_known_broken_failure_ "$@"
783                 return
784         fi
785         test_failure=$(($test_failure + 1))
786         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
787         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
788         return 1
789 }
790
791 test_failure_message_ () {
792         say_color error "%-6s" "$1"
793         echo " $2"
794         shift 2
795         if [ "$#" != "0" ]; then
796                 echo "$@" | sed -e 's/^/        /'
797         fi
798         if test "$verbose" != "t"; then cat test.output; fi
799 }
800
801 test_known_broken_ok_ () {
802         test_reset_state_
803         test_fixed=$(($test_fixed+1))
804         say_color pass "%-6s" "FIXED"
805         echo " $test_subtest_name"
806 }
807
808 test_known_broken_failure_ () {
809         test_reset_state_
810         test_broken=$(($test_broken+1))
811         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
812                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
813         else
814                 test_failure_message_ "BROKEN" "$test_subtest_name"
815         fi
816         return 1
817 }
818
819 test_debug () {
820         test "$debug" = "" || eval "$1"
821 }
822
823 test_run_ () {
824         test_cleanup=:
825         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
826         eval >&3 2>&4 "$1"
827         eval_ret=$?
828         eval >&3 2>&4 "$test_cleanup"
829         return 0
830 }
831
832 test_skip () {
833         test_count=$(($test_count+1))
834         to_skip=
835         for skp in $NOTMUCH_SKIP_TESTS
836         do
837                 case $this_test.$test_count in
838                 $skp)
839                         to_skip=t
840                         break
841                 esac
842                 case $this_test_bare.$test_count in
843                 $skp)
844                         to_skip=t
845                         break
846                 esac
847         done
848         case "$to_skip" in
849         t)
850                 test_report_skip_ "$@"
851                 ;;
852         *)
853                 test_check_missing_external_prereqs_ "$@"
854                 ;;
855         esac
856 }
857
858 test_check_missing_external_prereqs_ () {
859         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
860                 say_color skip >&1 "missing prerequisites: "
861                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
862                 test_report_skip_ "$@"
863         else
864                 false
865         fi
866 }
867
868 test_report_skip_ () {
869         test_reset_state_
870         say_color skip >&3 "skipping test:"
871         echo " $@" >&3
872         say_color skip "%-6s" "SKIP"
873         echo " $1"
874 }
875
876 test_subtest_known_broken () {
877         test_subtest_known_broken_=t
878 }
879
880 test_expect_success () {
881         exec 1>&6 2>&7          # Restore stdout and stderr
882         if [ -z "$inside_subtest" ]; then
883                 error "bug in the test script: test_expect_success without test_begin_subtest"
884         fi
885         inside_subtest=
886         test "$#" = 1 ||
887         error "bug in the test script: not 1 parameters to test_expect_success"
888
889         if ! test_skip "$test_subtest_name"
890         then
891                 test_run_ "$1"
892                 run_ret="$?"
893                 # test_run_ may update missing external prerequisites
894                 test_check_missing_external_prereqs_ "$@" ||
895                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
896                 then
897                         test_ok_
898                 else
899                         test_failure_ "$1"
900                 fi
901         fi
902 }
903
904 test_expect_code () {
905         exec 1>&6 2>&7          # Restore stdout and stderr
906         if [ -z "$inside_subtest" ]; then
907                 error "bug in the test script: test_expect_code without test_begin_subtest"
908         fi
909         inside_subtest=
910         test "$#" = 2 ||
911         error "bug in the test script: not 2 parameters to test_expect_code"
912
913         if ! test_skip "$test_subtest_name"
914         then
915                 test_run_ "$2"
916                 run_ret="$?"
917                 # test_run_ may update missing external prerequisites,
918                 test_check_missing_external_prereqs_ "$@" ||
919                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
920                 then
921                         test_ok_
922                 else
923                         test_failure_ "exit code $eval_ret, expected $1" "$2"
924                 fi
925         fi
926 }
927
928 # This is not among top-level (test_expect_success)
929 # but is a prefix that can be used in the test script, like:
930 #
931 #       test_expect_success 'complain and die' '
932 #           do something &&
933 #           do something else &&
934 #           test_must_fail git checkout ../outerspace
935 #       '
936 #
937 # Writing this as "! git checkout ../outerspace" is wrong, because
938 # the failure could be due to a segv.  We want a controlled failure.
939
940 test_must_fail () {
941         "$@"
942         test $? -gt 0 -a $? -le 129 -o $? -gt 192
943 }
944
945 # test_cmp is a helper function to compare actual and expected output.
946 # You can use it like:
947 #
948 #       test_expect_success 'foo works' '
949 #               echo expected >expected &&
950 #               foo >actual &&
951 #               test_cmp expected actual
952 #       '
953 #
954 # This could be written as either "cmp" or "diff -u", but:
955 # - cmp's output is not nearly as easy to read as diff -u
956 # - not all diff versions understand "-u"
957
958 test_cmp() {
959         $GIT_TEST_CMP "$@"
960 }
961
962 # This function can be used to schedule some commands to be run
963 # unconditionally at the end of the test to restore sanity:
964 #
965 #       test_expect_success 'test core.capslock' '
966 #               git config core.capslock true &&
967 #               test_when_finished "git config --unset core.capslock" &&
968 #               hello world
969 #       '
970 #
971 # That would be roughly equivalent to
972 #
973 #       test_expect_success 'test core.capslock' '
974 #               git config core.capslock true &&
975 #               hello world
976 #               git config --unset core.capslock
977 #       '
978 #
979 # except that the greeting and config --unset must both succeed for
980 # the test to pass.
981
982 test_when_finished () {
983         test_cleanup="{ $*
984                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
985 }
986
987 test_done () {
988         GIT_EXIT_OK=t
989         test_results_dir="$TEST_DIRECTORY/test-results"
990         mkdir -p "$test_results_dir"
991         test_results_path="$test_results_dir/$this_test"
992
993         echo "total $test_count" >> $test_results_path
994         echo "success $test_success" >> $test_results_path
995         echo "fixed $test_fixed" >> $test_results_path
996         echo "broken $test_broken" >> $test_results_path
997         echo "failed $test_failure" >> $test_results_path
998         echo "" >> $test_results_path
999
1000         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
1001
1002         if [ "$test_failure" = "0" ]; then
1003             if [ "$test_broken" = "0" ]; then
1004                 rm -rf "$remove_tmp"
1005             fi
1006             exit 0
1007         else
1008             exit 1
1009         fi
1010 }
1011
1012 emacs_generate_script () {
1013         # Construct a little test script here for the benefit of the user,
1014         # (who can easily run "run_emacs" to get the same emacs environment
1015         # for investigating any failures).
1016         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1017 #!/bin/sh
1018 export PATH=$PATH
1019 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1020
1021 # Here's what we are using here:
1022 #
1023 # --quick               Use minimal customization. This implies --no-init-file,
1024 #                       --no-site-file and (emacs 24) --no-site-lisp
1025 #
1026 # --directory           Ensure that the local elisp sources are found
1027 #
1028 # --load                Force loading of notmuch.el and test-lib.el
1029
1030 exec ${TEST_EMACS} --quick \
1031         --directory "$NOTMUCH_BUILDDIR/emacs" --load notmuch.el \
1032         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1033         "\$@"
1034 EOF
1035         chmod a+x "$TMP_DIRECTORY/run_emacs"
1036 }
1037
1038 test_emacs () {
1039         # test dependencies beforehand to avoid the waiting loop below
1040         missing_dependencies=
1041         test_require_external_prereq dtach || missing_dependencies=1
1042         test_require_external_prereq emacs || missing_dependencies=1
1043         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1044         test -z "$missing_dependencies" || return
1045
1046         if [ -z "$EMACS_SERVER" ]; then
1047                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1048                 if [ -f "$emacs_tests" ]; then
1049                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1050                 else
1051                         load_emacs_tests=
1052                 fi
1053                 server_name="notmuch-test-suite-$$"
1054                 # start a detached session with an emacs server
1055                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1056                 # or unknown) is given to dtach which assumes a minimally
1057                 # VT100-compatible terminal -- and emacs inherits that
1058                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1059                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1060                                 --no-window-system \
1061                                 $load_emacs_tests \
1062                                 --eval '(setq server-name \"$server_name\")' \
1063                                 --eval '(server-start)' \
1064                                 --eval '(orphan-watchdog $$)'" || return
1065                 EMACS_SERVER="$server_name"
1066                 # wait until the emacs server is up
1067                 until test_emacs '()' >/dev/null 2>/dev/null; do
1068                         sleep 1
1069                 done
1070         fi
1071
1072         # Clear test-output output file.  Most Emacs tests end with a
1073         # call to (test-output).  If the test code fails with an
1074         # exception before this call, the output file won't get
1075         # updated.  Since we don't want to compare against an output
1076         # file from another test, so start out with an empty file.
1077         rm -f OUTPUT
1078         touch OUTPUT
1079
1080         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1081 }
1082
1083 test_python() {
1084     # Note: if there is need to print debug information from python program,
1085     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1086     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1087         $NOTMUCH_PYTHON -B - > OUTPUT
1088 }
1089
1090 test_ruby() {
1091     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I "$NOTMUCH_BUILDDIR/bindings/ruby"> OUTPUT
1092 }
1093
1094 test_C () {
1095     local exec_file test_file
1096     exec_file="test${test_count}"
1097     test_file="${exec_file}.c"
1098     cat > ${test_file}
1099     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1100     echo "== stdout ==" > OUTPUT.stdout
1101     echo "== stderr ==" > OUTPUT.stderr
1102     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1103     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize > OUTPUT
1104 }
1105
1106 make_shim () {
1107     local base_name test_file shim_file
1108     base_name="$1"
1109     test_file="${base_name}.c"
1110     shim_file="${base_name}.so"
1111     cat > ${test_file}
1112     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1113 }
1114
1115 notmuch_with_shim () {
1116     local base_name shim_file
1117     base_name="$1"
1118     shift
1119     shim_file="${base_name}.so"
1120     LD_PRELOAD=./${shim_file}${LD_PRELOAD:+:$LD_PRELOAD} notmuch-shared "$@"
1121 }
1122
1123 # Creates a script that counts how much time it is executed and calls
1124 # notmuch.  $notmuch_counter_command is set to the path to the
1125 # generated script.  Use notmuch_counter_value() function to get the
1126 # current counter value.
1127 notmuch_counter_reset () {
1128         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1129         if [ ! -x "$notmuch_counter_command" ]; then
1130                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1131                 cat >"$notmuch_counter_command" <<EOF || return
1132 #!/bin/sh
1133
1134 read count < "$notmuch_counter_state_path"
1135 echo \$((count + 1)) > "$notmuch_counter_state_path"
1136
1137 exec notmuch "\$@"
1138 EOF
1139                 chmod +x "$notmuch_counter_command" || return
1140         fi
1141
1142         echo 0 > "$notmuch_counter_state_path"
1143 }
1144
1145 # Returns the current notmuch counter value.
1146 notmuch_counter_value () {
1147         if [ -r "$notmuch_counter_state_path" ]; then
1148                 read count < "$notmuch_counter_state_path"
1149         else
1150                 count=0
1151         fi
1152         echo $count
1153 }
1154
1155 test_reset_state_ () {
1156         test -z "$test_init_done_" && test_init_
1157
1158         test_subtest_known_broken_=
1159         test_subtest_missing_external_prereq_=()
1160 }
1161
1162 # called once before the first subtest
1163 test_init_ () {
1164         test_init_done_=t
1165
1166         # skip all tests if there were external prerequisites missing during init
1167         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1168 }
1169
1170
1171 # Where to run the tests
1172 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1173
1174 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1175
1176 emacs_generate_script
1177
1178
1179 # Use -P to resolve symlinks in our working directory so that the cwd
1180 # in subprocesses like git equals our $PWD (for pathname comparisons).
1181 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1182
1183 if test "$verbose" = "t"
1184 then
1185         exec 4>&2 3>&1
1186 else
1187         exec 4>test.output 3>&4
1188 fi
1189
1190 for skp in $NOTMUCH_SKIP_TESTS
1191 do
1192         to_skip=
1193         for skp in $NOTMUCH_SKIP_TESTS
1194         do
1195                 case "$this_test" in
1196                 $skp)
1197                         to_skip=t
1198                         break
1199                 esac
1200                 case "$this_test_bare" in
1201                 $skp)
1202                         to_skip=t
1203                         break
1204                 esac
1205         done
1206         case "$to_skip" in
1207         t)
1208                 say_color skip >&3 "skipping test $this_test altogether"
1209                 say_color skip "skip all tests in $this_test"
1210                 test_done
1211         esac
1212 done
1213
1214 # Provide an implementation of the 'yes' utility
1215 yes () {
1216         if test $# = 0
1217         then
1218                 y=y
1219         else
1220                 y="$*"
1221         fi
1222
1223         while echo "$y"
1224         do
1225                 :
1226         done
1227 }
1228
1229 # Fix some commands on Windows
1230 case $(uname -s) in
1231 *MINGW*)
1232         # Windows has its own (incompatible) sort and find
1233         sort () {
1234                 /usr/bin/sort "$@"
1235         }
1236         find () {
1237                 /usr/bin/find "$@"
1238         }
1239         sum () {
1240                 md5sum "$@"
1241         }
1242         # git sees Windows-style pwd
1243         pwd () {
1244                 builtin pwd -W
1245         }
1246         # no POSIX permissions
1247         # backslashes in pathspec are converted to '/'
1248         # exec does not inherit the PID
1249         ;;
1250 *)
1251         test_set_prereq POSIXPERM
1252         test_set_prereq BSLASHPSPEC
1253         test_set_prereq EXECKEEPSPID
1254         ;;
1255 esac
1256
1257 test -z "$NO_PERL" && test_set_prereq PERL
1258 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1259
1260 # test whether the filesystem supports symbolic links
1261 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1262 rm -f y
1263
1264 # declare prerequisites for external binaries used in tests
1265 test_declare_external_prereq dtach
1266 test_declare_external_prereq emacs
1267 test_declare_external_prereq ${TEST_EMACSCLIENT}
1268 test_declare_external_prereq ${TEST_GDB}
1269 test_declare_external_prereq gpg
1270 test_declare_external_prereq openssl
1271 test_declare_external_prereq gpgsm
1272 test_declare_external_prereq ${NOTMUCH_PYTHON}
1273 test_declare_external_prereq xapian-metadata